#=========================================
# HERMIT SID-WIZARD AUTOMATED COMPILATION
#-----------------------------------------
TASS="64tass"
PACKER="exomizer"
CBMDISK="c1541"
SOURCEDIR="."
BINARYDIR="../binary"
EXASWMDIR="../examples/modules"
EXASWIDIR="../examples/instruments"
APPNAME1="SID-Wizard"
APPNAME2="SID-Maker"
SWSOURCE=$APPNAME1".asm"
SMSOURCE=$APPNAME2".asm"
SWSPLASHSOURCE=$APPNAME1"-splashed.asm"
SWEXEC=$APPNAME1".prg"
SMEXEC=$APPNAME2".prg"
SWPACK=$APPNAME1"-packed.prg"
SMPACK=$APPNAME2"-packed.prg"
SWSPLASH=$APPNAME1"-splashed.prg"
SWLSOURCE=$APPNAME1"-light.asm"
SMLSOURCE=$APPNAME2"-light.asm"
SWLEXEC=$APPNAME1"-light.prg"
SMLEXEC=$APPNAME2"-light.prg"
SWLPACK=$APPNAME1"-packed-light.prg"
SMLPACK=$APPNAME2"-packed-light.prg"
SWMSOURCE=$APPNAME1"-medium.asm"
SMMSOURCE=$APPNAME2"-medium.asm"
SWMEXEC=$APPNAME1"-medium.prg"
SMMEXEC=$APPNAME2"-medium.prg"
SWMPACK=$APPNAME1"-packed-medium.prg"
SMMPACK=$APPNAME2"-packed-medium.prg"
SWMCONVERTER="SWMconvert"
REMOVE="rm -f"
COPY="cp -f"
ICON="SID-Wizard.png"
MENUENTRY=$APPNAME1".desktop"
CCOMPILER="gcc"
APPDIR="/usr/local/bin/"
# -----------------------------------
cd source
#
# -------- full version -------------
$TASS -o $BINARYDIR/$SWEXEC $SWSOURCE
$PACKER sfx sys -o $BINARYDIR/$SWPACK $BINARYDIR/$SWEXEC 
$TASS -o $BINARYDIR/$SWSPLASH $SWSPLASHSOURCE
#
$TASS -o $BINARYDIR/$SMEXEC $SMSOURCE
$PACKER sfx sys -o $BINARYDIR/$SMPACK $BINARYDIR/$SMEXEC 
#
$CBMDISK -format "sid-wizard disk,hm" d64 $BINARYDIR/$APPNAME1.d64
$CBMDISK -attach $BINARYDIR/$APPNAME1.d64 -write $BINARYDIR/$SWSPLASH sid-wizard 
$CBMDISK -attach $BINARYDIR/$APPNAME1.d64 -write $BINARYDIR/$SMPACK sid-maker
#
# -------- medium version ------------
#
$TASS -o $BINARYDIR/$SWMEXEC $SWMSOURCE
$PACKER sfx sys -o $BINARYDIR/$SWMPACK $BINARYDIR/$SWMEXEC 
#
$TASS -o $BINARYDIR/$SMMEXEC $SMMSOURCE
$PACKER sfx sys -o $BINARYDIR/$SMMPACK $BINARYDIR/$SMMEXEC 
#
$CBMDISK -format "sidwizard medium,hm" d64 $BINARYDIR/$APPNAME1-medium.d64
$CBMDISK -attach $BINARYDIR/$APPNAME1-medium.d64 -write $BINARYDIR/$SWMPACK sidwizard-medium 
$CBMDISK -attach $BINARYDIR/$APPNAME1-medium.d64 -write $BINARYDIR/$SMMPACK sid-maker-medium
#
# -------- light version ------------
#
$TASS -o $BINARYDIR/$SWLEXEC $SWLSOURCE
$PACKER sfx sys -o $BINARYDIR/$SWLPACK $BINARYDIR/$SWLEXEC 
#
$TASS -o $BINARYDIR/$SMLEXEC $SMLSOURCE
$PACKER sfx sys -o $BINARYDIR/$SMLPACK $BINARYDIR/$SMLEXEC 
#
$CBMDISK -format "sid-wizard light,hm" d64 $BINARYDIR/$APPNAME1-light.d64
$CBMDISK -attach $BINARYDIR/$APPNAME1-light.d64 -write $BINARYDIR/$SWLPACK sid-wizard-light 
$CBMDISK -attach $BINARYDIR/$APPNAME1-light.d64 -write $BINARYDIR/$SMLPACK sid-maker-light
#
# -------- add content (example tunes and instruments) --------------
$CBMDISK -attach $BINARYDIR/$APPNAME1.d64 -write $EXASWMDIR/*.prg example.swm 
$CBMDISK -attach $BINARYDIR/$APPNAME1.d64 -write $EXASWIDIR/*.prg example.swi
$COPY $EXASWMDIR/*.P00 $BINARYDIR
$COPY $EXASWIDIR/*.P00 $BINARYDIR
#
#--------- compile SWM-converter ------------------------------------
$CCOMPILER $SWMCONVERTER.c -o $BINARYDIR/$SWMCONVERTER -lm
$COPY $BINARYDIR/$SWMCONVERTER $APPDIR
cd ..
#===============================================================================
